/********************************************************
 *
 *  Copyright (c) 2015 Sony Corporation
 *
 ********************************************************/

#ifndef __ELBDRIVER_H__
#define __ELBDRIVER_H__

typedef struct {
    ulong          offset;
    ulong          size;
    void*          buf;
    ulong          area;
} LbmdIoctl_t;

/* Just a magic number for /dev/Altera */
/* See /usr/share/kernel/Documentation/ioctl-number.txt */
/* See /usr/src/kernels/2.6.18-274.17.1.el5-x86_64/include/asm-generic/ioctl.h */
#define IOC_MAGIC 0xFE

#define IOCTL_READ16        _IOR(IOC_MAGIC, 1, LbmdIoctl_t)
#define IOCTL_WRITE16       _IOW(IOC_MAGIC, 2, LbmdIoctl_t)
#define IOCTL_READ32        _IOR(IOC_MAGIC, 3, LbmdIoctl_t)
#define IOCTL_WRITE32       _IOW(IOC_MAGIC, 4, LbmdIoctl_t)
#define IOCTL_WAIT_VD       _IOR(IOC_MAGIC,10, LbmdIoctl_t)

#define DEVICE_NAME    "elb"
#define DEVICE_FILE    "/dev/elb"

//--- XVS1K Map ---
#define LBM_AREA_CS2          (0)
#define LBM_AREA_CS2_CS_FPGA  (1)
#define LBM_AREA_CS2_CADEC    (2)
#define LBM_AREA_CS2_VSW_FPGA (3)
#define LBM_AREA_CS3          (4)

#define LBM_CS2_ADDRESS       (0x90000000)
#define LBM_CS2_CS_ADDRESS    (0x90100000)
#define LBM_CS2_CADEC_ADDRESS (0x91000000)
#define LBM_CS2_VSW_ADDRESS   (0x98000000)
#define LBM_CS3_ADDRESS       (0xA0000000)

#define LBM_CS2_SIZE          (0x00020000) // 128K
#define LBM_CS2_CS_SIZE       (0x00100000) // 1M
#define LBM_CS2_CADEC_SIZE    (0x00200000) // 2M
#define LBM_CS2_VSW_SIZE      (0x00500000) // 5M
#define LBM_CS3_SIZE          (0x00200000) // 2M

//---4K DME Map ---
#define LBM_BAR_CADEC        (0)
#define LBM_BAR_FPGA         (1)
#define LBM_BAR_CADEC_CONFIG (2)
#define LBM_BAR_DEBUG        (3)

#define LBM_ADDR_CS2_CADEC        (0xA0000000)
#define LBM_ADDR_CS3_FPGA         (0xB0000000)
#define LBM_ADDR_CS3_CADEC_CONFIG (0xB1d40000)

#define LBM_SIZE_CS2_CADEC        (0x00014000) //80K
#define LBM_SIZE_CS3_FPGA         (0x01d40000) //29M
#define LBM_SIZE_CS3_CADEC_CONFIG (0x00400000) // 4M


#endif // __ELBDRIVER_H__
