#!/bin/sh

# chkconfig: 2345 6 94
# description: install drivers

readonly CUR_DIR=`dirname $0`
readonly DRV_DIR="./"

function ins_drv() {
    local driver_name="${DRV_DIR}/${1}.ko"
    lsmod | grep "$1"
    if [ $? -eq 1 ]; then
        insmod $driver_name;
        if [ $? != 0 ]; then
            exit 1
        fi
    fi
}

function make_node() {
    ls /dev | grep "$1"
    if [ $? -eq 1 ]; then
        major=`grep -w $1 /proc/devices | cut -f1 -d" "`
        mknod /dev/$1 c $major 0
        if [ $? != 0 ]; then
            exit 2
        fi
    fi
}

function stop_watchdog_timer() {
    ${ELB_WRITE} 1 a0 1 00
}

ret=0

ins_drv   "elbdriver"
make_node "elb"
exit $ret
